
package cn.orionsec.ops.handler.exporter;

import cn.orionsec.kit.lang.utils.convert.Converts;
import cn.orionsec.kit.spring.SpringHolder;
import cn.orionsec.ops.constant.ExportType;
import cn.orionsec.ops.constant.event.EventKeys;
import cn.orionsec.ops.dao.WebhookConfigDAO;
import cn.orionsec.ops.entity.domain.WebhookConfigDO;
import cn.orionsec.ops.entity.exporter.WebhookExportDTO;
import cn.orionsec.ops.entity.request.data.DataExportRequest;
import cn.orionsec.ops.utils.EventParamsHolder;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Objects;

public class WebhookDataExporter extends AbstractDataExporter<WebhookExportDTO> {

    private static final WebhookConfigDAO webhookConfigDAO = SpringHolder.getBean(WebhookConfigDAO.class);

    public WebhookDataExporter(DataExportRequest request, HttpServletResponse response) {
        super(ExportType.WEBHOOK, request, response);
    }

    @Override
    protected List<WebhookExportDTO> queryData() {
        // 查询数据
        Integer type = request.getType();
        LambdaQueryWrapper<WebhookConfigDO> wrapper = new LambdaQueryWrapper<WebhookConfigDO>()
                .eq(Objects.nonNull(type), WebhookConfigDO::getWebhookType, type);
        List<WebhookConfigDO> list = webhookConfigDAO.selectList(wrapper);
        return Converts.toList(list, WebhookExportDTO.class);
    }

    @Override
    protected void setEventParams() {
        super.setEventParams();
        EventParamsHolder.addParam(EventKeys.TYPE, request.getType());
    }

}
